﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TSP.Algorithm;

namespace cv6_vecer
{
    class Program
    {
        static void Main(string[] args)
        {
            //Console.WriteLine(string.Format("Current version of CLR: {0}", Environment.Version));
            City[] cities = new[]
                                {
                                    new City(50.083333, 14.416667, "Prague"),
                                    new City(37.566536, 126.977969, "Seoul"),
                                    new City(33.583333, 130.4, "Fukuoka"),
                                    new City(3.1475,101.693333, "Kuala Lumpur"),
                                    new City(5.971389, 116.095278, "Kota Kinabalu"),
                                    new City(48.866667, 2.333333, "Paris"),
                                    new City(51.507222, -0.1275, "London"),
                                    new City(34.05, -118.25, "L.A."),
                                    new City(40.664167, -73.938611, "NYC"),
                                    new City(36.175, -115.136389, "Las Vegas"),
                                    new City(52.500556, 13.398889, "Berlin"),
                                    new City(54.966667, -1.6, "Newcastle upon Tyne"),
                                    new City(47.266667, 11.383333, "Insbruck"),
                                    new City(41.9, 12.5, "Rome"),
                                    new City(37.7793, -122.4192, "San Francisco"),
                                    new City(21.308889, -157.826111, "Honolulu"),
                                };

            GeneticAlgorithm ga = new GeneticAlgorithm();
            ga.Initialize(cities);

            for (int i = 0; i < 1000; i++)
            {
                ga.Iterate();
                Console.WriteLine(string.Format("Best cost so far: {0}, in generation {1}", ga.BestCost, ga.GenerationCount));
                if (ga.Status == ExecutionStatus.Completed) break;
            }

            Console.WriteLine(string.Format("Best cost: {0}", ga.BestCost));

            string order = "";

            foreach (int indexToCities in ga.BestChromosome.Genes)
            {
                order += string.Format(" -> {0}", cities[indexToCities].Name);
            }

            Console.WriteLine(order);
            
            Console.ReadKey();
        }
    }
}
